Option explicit
option default NONE
'
' program to convert a binary .PPM file to a .565 file
'
dim s$
do
 input "Filename to convert (X to exit) ? ",s$
 if s$<>"X" then Conv565(s$)
loop until s$="X" or s$="x"

Sub Conv565(PIC$) 
  LOCAL Buffer$,buffer2$,pic2$,addbuffer$ length 3
  LOCAL numBytes%, a%, x%, y%, n%
  pic2$=left$(pic$,len(pic$)-3)+"565"   
  open pic$ for random as #1
  open pic2$ for random as #2
  seek #2,1
  seek #1,1
  if lof(#1)=0 then
    close #1
    close #2
    kill pic$
    kill pic2$
    print "No such file"
  else
    'Read the first 128 bytes   
    buffer$=input$(128,#1)
    a%=instr(buffer$,chr$(10)) ' look for the first CR   
    if left$(buffer$,a%-1)="P6" then    
      buffer$=right$(buffer$,len(buffer$)-a%) 
      if left$(buffer$,1)="#" then  
        a%=instr(buffer$,chr$(10)) ' look for the second CR   
        buffer$=right$(buffer$,len(buffer$)-a%)   
      endif
      a%=instr(buffer$,chr$(32)) ' look for the space between dimensions   
      x%=val(left$(buffer$,a%-1))   
      buffer$=right$(buffer$,len(buffer$)-a%)   
      a%=instr(buffer$,chr$(10)) ' look for the third CR   
      y%=val(left$(buffer$,a%-1))  
      print #2,str$(x%,4)+str$(y%,4);
      numbytes%=x%*y%*3 
      buffer$=right$(buffer$,len(buffer$)-a%)   
      a%=instr(buffer$,chr$(10)) ' look for the fourth CR   
      buffer$=right$(buffer$,len(buffer$)-a%)   
      a%=len(buffer$) mod 3   
      if a% then
        addBuffer$=input$(3-a%,#1) ' we need to make sure we have a number of bytes divisible by three in the buffer   
        buffer$=buffer$+addbuffer$  
      endif
      rgb565(buffer$,buffer2$)
      print #2,buffer2$;
      numbytes%=numbytes%-len(buffer$)
      do while numbytes%>255  
        buffer$=input$(255,#1)    
        rgb565(buffer$,buffer2$)
        print #2,buffer2$;
        numbytes%=numbytes%-255
        if n% mod 16 = 0 then print ".";
        n%=n%+1
        if n% mod 1024 = 0 then print ""
      loop
      buffer$=input$(numbytes%,#1)
      rgb565(buffer$,buffer2$)
      print #2,buffer2$;
      print ""
    else   
      Print "Invalid File Format"   
    endif
    close #1  
    close #2
  endif
  end sub
  
CSub rgb565
    00000000
    90820000 24030003 0043001A 006001F4 28460002 00001812 00031840 14C00014 
    A0A30000 24030001 240AFFF8 90860002 90870001 90880003 000648C0 01473824 
    312900E0 000840C2 24630003 00063142 00E63025 01284025 0062382A A0A60001 
    A0A80002 24840003 14E0FFF0 24A50002 03E00008 00000000 
End CSub
